;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Soubor:  sem-tam-tlac.asm
; Datum:   30.01.2012 14:57
; Autor:   Marek Nožka, nozka <@t> spseol <d.t> cz
; Licence: GNU/GPL 
; Úloha:   světlo se pohybuje zleva doprava a
;          zprava doleva
; Popis:   práce s tlačítem
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
tlacitko bit P1.0 ; při stidku tlačítka L, jinak H
PORT EQU P0       ; symbol představující port

mov DPTR, #svetlo ; uloží adresu tabulky
mov R0, #0        
zac:
    call zobrazuj
    call del100m
    jmp zac

; podprogram přepíš registr R0 na port 7-segment
zobrazuj:
    jnb tlacitko, preskoc
    mov A, R0            ; v A je číslo, které chci zobrazit
    movc A,@A+DPTR       ; číslo, které chci zobrazit najdu v tabulce a uložím opět do A
    mov PORT, A          ; zobrazím číslo vytažené z tabulky
    inc R0               ; zvýší hodnotu R0 o 1
    cjne R0, #14,preskoc ; v tabulce je 14 pozic
    mov R0, #0        
preskoc:    
    RET

;; tabulka číslic displaye
svetlo:  db 01111111b  ; 
         db 10111111b  ; 
         db 11011111b  ; 
         db 11101111b  ; 
         db 11110111b  ; 
         db 11111011b  ; 
         db 11111101b  ; 
         db 11111110b  ; 
         db 11111101b  ; 
         db 11111011b  ; 
         db 11110111b  ; 
         db 11101111b  ; 
         db 11011111b  ; 
         db 10111111b  ; 

include delay12MHz.inc

END
