/* Soubor:  delay12MHz.c
 * Datum:   05.01.2012 14:20
 * Autor:   Marek Nožka, nozka <@t> spseol <d.t> cz
 * Licence: GNU/GPL 
 * Úloha: 
 * Popis:   
 */

/***********************************
 *      Symbolické konstanty 
 ***********************************/
//#define FOO 451

/***********************************
 *   Hlavičkové soubory
 ***********************************/
//#include <at89x52.h>

#include "delay12MHz.h"

/*********************************** 
 *  Globální proměnné a datové struktury
 ***********************************/
//static 

/*********************************** 
 *  Implementace funkcí
 ***********************************/

/** Funkce pro časové zpoždění 10 ms až 2550 ms.
 * (Pro OSC 12.0 MHz) Časové zpoždění je vždy násobkem 10 ms.
 * Režije spojená s voláním funkce k zadanému zpoždění
 * přidává ještě dalších 8 us.
 *
 * @param koef Celkové zpoždění = koef x 10ms. */
void delay_10m_x(unsigned char koef) //%.h
{
    koef; //pouze prázdný výraz, abych nedostával warning při kompilaci
    __asm
    MOV R5,DPL
        ; 10ms    
00001$: MOV	R6, #49
00002$:     MOV R7, #100
            NOP
00003$:         DJNZ R7, 00003$
            DJNZ R6, 00002$
        DJNZ R5, 00001$
    __endasm;
}

/** Funkce pro časové zpoždění 1 ms až 255 ms.
 * (Pro OSC 12.0 MHz) Časové zpoždění je vždy násobkem 1 ms.
 * Režije spojená s voláním funkce k zadanému zpoždění
 * přidává ještě dalších 6 us.
 *
 * @param koef Celkové zpoždění = koef x 100us. */
void delay_1m_x(unsigned char koef) //%.h
{
    koef; //pouze prázdný výraz, abych nedostával warning při kompilac
    __asm
    MOV R6, DPL 
    ; 1000 us 
00002$: MOV R7, #249
00003$:     NOP
            NOP
            DJNZ R7, 00003$
        NOP    
        DJNZ R6, 00002$ 
    __endasm;
}

/** Funkce pro časové zpoždění 100 us až 25500 us.
 * (Pro OSC 12.0 MHz) Časové zpoždění je vždy násobkem 100 us.
 * Režije spojená s voláním funkce k zadanému zpoždění
 * přidává ještě dalších 6 us.
 *
 * @param koef Celkové zpoždění = koef x 100us. */
void delay_100u_x(unsigned char koef) //%.h
{
    koef; //pouze prázdný výraz, abych nedostával warning při kompilac
    __asm
    MOV R6, DPL 
    ; 100 us 
00002$: MOV R7, #48
00003$:     DJNZ R7, 00003$
        NOP 
        DJNZ R6, 00002$ 
    __endasm;
}

